﻿#region MyJScript - LGPL Copyright (c) 2008 Lionel Laské
//
// This file is part of MyJScript.
//
// MyJScript is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
//
// MyJScript is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with MyJScript; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//
//================================================================================
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Scripting;
using Microsoft.Scripting.Runtime;

namespace MyJScript.Runtime
{
    /// <summary>
    /// Class for MyJScript current context.
    /// </summary>
    public class MJSContext
    {
        /// <summary>
        /// Singleton for global object
        /// </summary>
        static MJSObject @this = null;

        /// <summary>
        /// Get global context.
        /// </summary>
        /// <returns>context</returns>
        public static MJSObject GetContext()
        {
            if (@this == null)
            {
                // Create context, assign "this"
                @this = new MJSObject();
                @this.Set("this", @this);
            }
            return @this;
        }

        /// <summary>
        /// Load package in context.
        /// </summary>
        /// <param name="context">DLR context for call</param>
        /// <param name="name">library name</param>
        /// <returns>package</returns>
        public static object UseLibrary(CodeContext context, string name)
        {
            object value;
            if (context.LanguageContext.DomainManager.Globals.TryGetName(SymbolTable.StringToId(name), out value))
                return value;
            return null;
        }
    }
}
